import 'dart:convert';
import 'package:google_applovin_unity_ads/ads/SettingsModel.dart';
import 'package:http/http.dart' as http;

Settings? _settings;

Future<Settings?> fetchAdsSettings({required String settingsUrl,  String? keyName}) async {
  final response = await http.get(Uri.parse(settingsUrl));
  if (response.statusCode == 200) {
    return convertAdsSettings(jsonData:response.body, keyName: keyName);
  } else {
    return null;
  }
}

Future<Settings?> convertAdsSettings({required String jsonData,  String? keyName}) async {
  if (keyName == null || keyName == "") {
    _settings = Settings.fromJson(jsonDecode(jsonData));
  } else {
    _settings = _Response.fromJson(jsonDecode(jsonData), keyName).response;
  }
  return _settings;
}


Settings? getAdsSettings() {
  return _settings;
}

class _Response {
  Settings? response;

  _Response({this.response});

  _Response.fromJson(Map<String, dynamic> json, String keyName) {
    response = json[keyName] != null
        ? Settings.fromJson(
        json[keyName])
        : null;
  }
}